# PV Performance Labs Tools for Python

*Useful tools for photovoltaics and beyond!*

<p align="left">
  <table>
    <tr>
      <td>PyPI version</td>
      <td>
        <a href="https://badge.fury.io/py/pvpltools">
          <img src="https://badge.fury.io/py/pvpltools.svg" alt="PyPI version" height="18"/>
        </a>
      </td>
    </tr>
    <tr>
      <td>License</td>
      <td>
        <a href="https://github.com/pvplabs/pvpltools/blob/main/LICENSE">
          <img src="https://img.shields.io/pypi/l/pvpltools.svg" alt="license" />
        </a>
      </td>
    </tr>
    <tr>
      <td>Build status</td>
      <td>
        <a href="http://pvpltools.readthedocs.org/en/latest/">
          <img src="https://readthedocs.org/projects/pvpltools/badge/?version=latest" alt="documentation build status" />
        </a>
        <a href="https://github.com/pvplabs/pvpltools/actions/workflows/pytest.yml?query=branch%3Amain">
          <img src="https://github.com/pvplabs/pvpltools/actions/workflows/pytest.yml/badge.svg?branch=main" alt="GitHub Actions Testing Status" />
        </a>
        <a href="https://codecov.io/gh/pvplabs/pvpltools">
          <img src="https://codecov.io/gh/pvplabs/pvpltools/branch/main/graph/badge.svg" alt="codecov coverage" />
        </a>
      </td>
  </table>
</p>

This package, **pvpltools**, makes available a collection of useful
software components and functions created by Anton Driesse of PV Performance Labs.
Many were developed in the context of consulting or research projects,
sometimes as a necessity, and sometimes just to make life easier.

The aim of this package is to make life easier for people facing similar needs
and thereby, in a small way, support the accelerated deployment of photovoltaic power systems.


Copyright
---------

Copyright (c) 2019-2025 Anton Driesse, PV Performance Labs.


License
-------

GPL-3.0, but feel free to let me know if that causes any problems!


Citing
------

When referring to this software in an academic or commercial context,
please use a citation similar to the following:

  A. Driesse,
  "PV Performance Labs Tools for Python", (2025), GitHub repository,
  https://github.com/pvplabs/pvpltools

When referring to specific functions, docs strings or algorithms,
please add specifics to the citation.
Docstrings also contain references to relevant publications.


Acknowledgements
----------------

Parts of this repository have been developed
in the context of consulting or research projects,
sometimes as a necessity, and sometimes just to make life easier.

The development of this package has not been funded directly,
but I nevertheless want to acknowledge research project funding
and/or encouragement to publish open source code
from the following organizations:

 - Sandia National Laboratories
 - United States Department of Energy
 - Fraunhofer Institute for Solar Energy
 - German Aerospace Center
 - German Ministry for Economic Affairs and Climate Action


I also acknowledge and thank all the contributors to pvlib-python,
parts of which I use frequently in the context of my work.


Getting help
------------

The first place to look is https://pvpltools.readthedocs.io/en/latest/.
If it's not adequately explained there, have a look at
the source code--if you're a user, you must be a programmer!
Still confused? Send me an email.

For commercial use, extended support and related services are available.
